// test.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"


#define DF_INTER	0
#define DF_USE		1
#define DF_PROCEDURE 0



#if DF_PROCEDURE

//ms-help://MS.VSCC.v90/MS.MSDNQTR.v90.ko/dllproc/base/using_condition_variables.htm
//test.exe -   
//ν   WakeCondition Variable() DLL KERNEL32.dll ã  ϴ.

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

#define BUFFER_SIZE 10
#define PRODUCER_SLEEP_TIME_MS 500
#define CONSUMER_SLEEP_TIME_MS 2000

LONG Buffer[BUFFER_SIZE];
LONG LastItemProduced;
ULONG QueueSize;
ULONG QueueStartOffset;

ULONG TotalItemsProduced;
ULONG TotalItemsConsumed;

CONDITION_VARIABLE BufferNotEmpty;
CONDITION_VARIABLE BufferNotFull;
CRITICAL_SECTION   BufferLock;

BOOL StopRequested;

DWORD WINAPI ProducerThreadProc (PVOID p)
{
    ULONG ProducerId = (ULONG)(ULONG_PTR)p;

    while (true)
    {
        // Produce a new item.

        Sleep (rand() % PRODUCER_SLEEP_TIME_MS);

        ULONG Item = InterlockedIncrement (&LastItemProduced);

        EnterCriticalSection (&BufferLock);

        while (QueueSize == BUFFER_SIZE && StopRequested == FALSE)
        {
            // Buffer is full - sleep so consumers can get items.
//s            SleepConditionVariableCS (&BufferNotFull, &BufferLock, INFINITE);
        }

        if (StopRequested == TRUE)
        {
            LeaveCriticalSection (&BufferLock);
            break;
        }

        // Insert the item at the end of the queue and increment size.

        Buffer[(QueueStartOffset + QueueSize) % BUFFER_SIZE] = Item;
        QueueSize++;
        TotalItemsProduced++;

        printf ("Producer %u: item %2d, queue size %2u\r\n",
            ProducerId, Item, QueueSize);

        LeaveCriticalSection (&BufferLock);

        // If a consumer is waiting, wake it.

//s        WakeConditionVariable (&BufferNotEmpty);
    }

    printf ("Producer %u exiting\r\n", ProducerId);
    return 0;
}

DWORD WINAPI ConsumerThreadProc (PVOID p)
{
    ULONG ConsumerId = (ULONG)(ULONG_PTR)p;

    while (true)
    {
        EnterCriticalSection (&BufferLock);

        while (QueueSize == 0 && StopRequested == FALSE)
        {
            // Buffer is empty - sleep so producers can create items.
//s            SleepConditionVariableCS (&BufferNotEmpty, &BufferLock, INFINITE);
        }

        if (StopRequested == TRUE && QueueSize == 0)
        {
            LeaveCriticalSection (&BufferLock);
            break;
        }

        // Consume the first available item.

        LONG Item = Buffer[QueueStartOffset];

        QueueSize--;
        QueueStartOffset++;
        TotalItemsConsumed++;

        if (QueueStartOffset == BUFFER_SIZE)
        {
            QueueStartOffset = 0;
        }

        printf ("Consumer %u: item %2d, queue size %2u\r\n", 
            ConsumerId, Item, QueueSize);

        LeaveCriticalSection (&BufferLock);

        // If a producer is waiting, wake it.

//s        WakeConditionVariable (&BufferNotFull);

        // Simulate processing of the item.

        Sleep (rand() % CONSUMER_SLEEP_TIME_MS);
    }

    printf ("Consumer %u exiting\r\n", ConsumerId);
    return 0;
}

void __cdecl wmain (int argc, const wchar_t* argv[])
{
//s    InitializeConditionVariable (&BufferNotEmpty);
//s    InitializeConditionVariable (&BufferNotFull);

    InitializeCriticalSection (&BufferLock);

    DWORD id;
    HANDLE hProducer1 = CreateThread (
        NULL, 0, ProducerThreadProc, (PVOID)1, 0, &id);
    HANDLE hConsumer1 = CreateThread (
        NULL, 0, ConsumerThreadProc, (PVOID)1, 0, &id);
    HANDLE hConsumer2 = CreateThread (
        NULL, 0, ConsumerThreadProc, (PVOID)2, 0, &id);

    puts ("Press enter to stop...");
    getchar();

    EnterCriticalSection (&BufferLock);
    StopRequested = TRUE;
    LeaveCriticalSection (&BufferLock);

//s    WakeAllConditionVariable (&BufferNotFull);
//s    WakeAllConditionVariable (&BufferNotEmpty);

    WaitForSingleObject (hProducer1, INFINITE);
    WaitForSingleObject (hConsumer1, INFINITE);
    WaitForSingleObject (hConsumer2, INFINITE);

    printf ("TotalItemsProduced: %u, TotalItemsConsumed: %u\r\n", 
        TotalItemsProduced, TotalItemsConsumed);
}



#endif


#if DF_INTER


#include <vector>
using namespace std;

#include <iostream>
#include <Windows.h>
#include <process.h>

//. Լ 漱
unsigned int WINAPI InterLocked1(void* arg);
unsigned int WINAPI InterLocked2(void* arg);

//.  
int const MAX_COUNT = 1000;

//.  
DWORD     _total = 0;
int       _count = 0;

vector<int> v;


//
void fn_cos()
{
}


//	SYSTEMTIME st;
//	GetLocalTime(&st);
LARGE_INTEGER t_start, t_end, t_tick, t_diff;

void fn_start_timer()
{
	QueryPerformanceCounter(&t_start);
}

double fn_end_timer()
{
	double timeSecond;
	QueryPerformanceCounter(&t_end);
	QueryPerformanceFrequency(&t_tick);

	t_diff.QuadPart = t_end.QuadPart - t_start.QuadPart;
	timeSecond = (double) ((double)t_diff.QuadPart/(double)t_tick.QuadPart);

//	TRACE ("Elapsed CPU time:   %3.12f  sec / ticksPerSecond: %I64Ld\n", timeSecond, t_diff.QuadPart);
	return timeSecond;
}


void main()
{
	DWORD  id_1, id_2;
	HANDLE hand_1, hand_2;
	hand_1 = (HANDLE)_beginthreadex(NULL,0,InterLocked1,0,0,(unsigned int*)&id_1);
	hand_2 = (HANDLE)_beginthreadex(NULL,0,InterLocked2,0,0,(unsigned int*)&id_2);
	WaitForSingleObject(hand_1, INFINITE);
	WaitForSingleObject(hand_2, INFINITE);
}

///////////////////////// °  /////////////////////////
unsigned int WINAPI InterLocked1(void* arg)
{
	while( 1 )
	{
		++_count;

		//0.000267
		fn_start_timer();
		for(int i=0; i<10000; i++)
		InterlockedIncrement((volatile long *)&_total);
		double time = fn_end_timer();
		printf("xxxxxxxA - %f\n", time);

		//  std::cout<<"InterLocked1 : "<<_total<<std::endl;
		int size = v.size();
		if(size > 0)
		{
			for(int i=0; i<100; i++)
			int r = v.at(0);
		}
		printf("A %d\n", size);
	}
	std::cout<<"InterLocked1  : "<<_total<<std::endl;
	_endthreadex(0);
	return (DWORD)arg;
}

unsigned int WINAPI InterLocked2(void* arg)
{
	while( 1 )
	{
		++_count;

		//0.000267
		fn_start_timer();
		for(int i=0; i<10000; i++)
		InterlockedIncrement((volatile long *)&_total);
		double time = fn_end_timer();
		printf("xxxxxB - %f\n", time);

		//  std::cout<<"                                            InterLocked2 : "<<_total<<std::endl;
		v.push_back(_count);
		int size = v.size();
		printf("                                                     B %d\n", size);
	}
	std::cout<<"\tInterLocked2  : "<<_total<<std::endl;
	_endthreadex(0);
	return (DWORD)arg;
}



#endif




#if DF_USE


#include <windows.h>
#include <process.h>	//_beginthreadex

// ũ //http://blog.naver.com/saram95?Redirect=Log&logNo=90092813334
#include <vector>
using namespace std;


CRITICAL_SECTION cs;
CRITICAL_SECTION cs1;
CRITICAL_SECTION cs2;

//typedef struct DF_VECTOR
class CVector
{
public:
	CVector()		{	use = 1;	};
	~CVector()	{				};
public:
	int use;
	vector<int> v;
public:
	int fn_at( int data_index );
	int fn_size();
	int fn_push( int data );
};

int CVector::fn_at( int data_index )
{
	//̸. .
	if(use == 1)
	{
		return -1;
	}

	// ʰ .  
	EnterCriticalSection(&cs);
	use = 1;						//  Դϴ.
	int size = v.at( data_index );
	LeaveCriticalSection(&cs);
	use = 0;						// Ϸ
	return size;
}

int CVector::fn_size()
{
	//̸. .
	if(use == 1)
	{
		return -1;
	}

	// ʰ .  
	EnterCriticalSection(&cs);
	use = 1;						//  Դϴ.
	int size = v.size();
	LeaveCriticalSection(&cs);
	use = 0;						// Ϸ
	return size;
}

int CVector::fn_push(int data)
{
	//̸. .
	if(use == 1)
	{
		return -1;
	}

	// ʰ .  
	EnterCriticalSection(&cs);
	use = 1;						//  Դϴ.
	v.push_back(data);
	LeaveCriticalSection(&cs);
	use = 0;						// Ϸ
	return 0;
}



//	SYSTEMTIME st;
//	GetLocalTime(&st);
LARGE_INTEGER t_start, t_end, t_tick, t_diff;

void fn_start_timer()
{
	QueryPerformanceCounter(&t_start);
}

double fn_end_timer()
{
	double timeSecond;
	QueryPerformanceCounter(&t_end);
	QueryPerformanceFrequency(&t_tick);

	t_diff.QuadPart = t_end.QuadPart - t_start.QuadPart;
	timeSecond = (double) ((double)t_diff.QuadPart/(double)t_tick.QuadPart);

//	TRACE ("Elapsed CPU time:   %3.12f  sec / ticksPerSecond: %I64Ld\n", timeSecond, t_diff.QuadPart);
	return timeSecond;
}



//}ST_VECTOR;
CVector cv;
int cnt = 0;
vector<int> v;
int use = 1;
unsigned int WINAPI th1 ( void* parg )
{
	use = 0;
	int local_cnt = 0;
	while(1)
	{
		//̸. .
		if(use == 1)
		{
			continue;
		}


		//0.000547
		use = 1;						//  Դϴ.
		fn_start_timer();
		for(int i=0; i<10000; i++)
		{
//			EnterCriticalSection(&cs);
//			LeaveCriticalSection(&cs);
		}
		double time = fn_end_timer();
		printf("vvvvvvvvvA - %f\n", time);


		// ʰ .  
		use = 1;						//  Դϴ.
//		EnterCriticalSection(&cs);
		printf("A1  %d\n", local_cnt);	//

		int size = v.size();
		if( size > 0 )
		{
			for(int i=0; i<100; i++)
			int r = v.at( size - 1 );		//
			v.pop_back();
			local_cnt = size;
		}

		printf("A2   X     %d\n", local_cnt);	//
//		LeaveCriticalSection(&cs);
		use = 0;						// Ϸ

		Sleep(20);
	}
	_endthreadex(0);
	return 0;
}


unsigned int WINAPI th2 ( void* parg )
{
	while(1)
	{
		//̸. .
		if(use == 1)
		{
			continue;
		}

		//0.000547
		use = 1;						//  Դϴ.
		fn_start_timer();
		for(int i=0; i<10000; i++)
		{
//			EnterCriticalSection(&cs);
//			LeaveCriticalSection(&cs);
		}
		double time = fn_end_timer();
		printf("                                    vvvvvvvvvB - %f\n", time);


		// ʰ .  
		use = 1;						//  Դϴ.
		printf("                                    B2   %d\n", cnt);	//
//		EnterCriticalSection(&cs);

		v.push_back( cnt );
		int size = v.size();

		printf("                                    B2          %d\n", size);	//
//		LeaveCriticalSection(&cs);
		use = 0;						// Ϸ

		cnt++;
		Sleep(10);
	}
	_endthreadex(0);
	return 0;
}


//unsigned int WINAPI th1 ( void* parg )
//{
//	int local_cnt = 0;
//	while(1)
//	{
//		printf("A  111\n");	//
//////		bool b = TryEnterCriticalSection(&cs);			//1111111111111111
//////		if( b == 0)	// : ̴.
////		{
////			printf("A  2222222\n");	//
//////			continue;
////		}
////		else
////		{
//////			EnterCriticalSection(&cs);
////		}
//
//		printf("A  33333333333\n");	//				//1111111111111111
//		int size = cv.fn_size();
//		if( size > 0 )
//		{
//			int r = cv.fn_at( local_cnt );
////			int r = v.at( local_cnt );		//
////			v.pop_back();
//			local_cnt++;
//			printf("A Էµ   : %d\n", r);	//
////			LeaveCriticalSection(&cs);
//		}
//		else
//		{
//			printf("A  0Դϴ. %d\n", size);	//
////			LeaveCriticalSection(&cs);
//		}
//		Sleep(10);
//	}
//	_endthreadex(0);
//	return 0;
//}
//
//
//unsigned int WINAPI th2 ( void* parg )
//{
//	while(1)
//	{
//		printf("--------------------------B  111\n");	//
////		bool b = TryEnterCriticalSection(&cs);					//22222222222222222222
////		if( b == 0)	// : ̴.
////		{
////			printf("--------------------------B  2222222\n");	//
////			continue;
////		}
////		else
////		{
//////			EnterCriticalSection(&cs);
////		}
//
//		printf("--------------------------B  33333333333\n");	//	//22222222222222222222
//		cv.fn_push(cnt);		//ֱ
//		int r = cv.fn_at( cnt );		//
////		LeaveCriticalSection(&cs);
//		printf("--------------------------B Էµ   : %d\n", r);	//
//		printf("--------------------------B  4444444444444444\n");	//
//		cnt++;
//		Sleep(10);
//	}
//	_endthreadex(0);
//	return 0;
//}

int _tmain(int argc, _TCHAR* argv[])
{

	::InitializeCriticalSection(&cs);
	::InitializeCriticalSection(&cs1);
	::InitializeCriticalSection(&cs2);

	//http://qhfk984z.blog.me/150162436824
	DWORD id1;
	DWORD id2;
	HANDLE handle1;
	HANDLE handle2;
	handle1 = (HANDLE) ::_beginthreadex(NULL, 0, th1, 0, 0, (unsigned int*)&id1);
	handle2 = (HANDLE) ::_beginthreadex(NULL, 0, th2, 0, 0, (unsigned int*)&id2);
	WaitForSingleObject(handle1, INFINITE);
	WaitForSingleObject(handle2, INFINITE);
	CloseHandle(handle1);
	CloseHandle(handle2);

	//
//	v.push_back(11);		//ֱ
//	v.pop_back();			//
//	int r = v.at(0);		//ù° 
//	printf("%d\n", r);	//

	::DeleteCriticalSection(&cs);
	::DeleteCriticalSection(&cs1);
	::DeleteCriticalSection(&cs2);

	system("pause");		//
	return 0;
}


#endif
